// General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
// base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
// The model can simulate OLEDs, Perovskite cells, and OFETs.
// 
// Copyright (C) 2008-2020 Roderick C. I. MacKenzie
// All rights reserved.
// 
// https://www.gpvdm.com
// r.c.i.mackenzie at googlemail.com
// 
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the GPVDM nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sim.h"
#include <math.h>

void join_tpv_to_ce(struct device *in)
{
static struct istruct vocce;
static struct istruct voctau;
static struct istruct nk;

int i;
inter_load_a(&vocce,"./exp/tpv/vocce.dat",0,1);
inter_load_a(&voctau,"./exp/tpv/voctau.dat",0,1);
inter_load_a(&nk,"./exp/tpv/voctau.dat",0,1);
double C=in->xlen*in->zlen*epsilon0*3.8/in->ylen;
double Qcap=0.0;
for (i=0;i<voctau.len;i++)
{
	double tau=voctau.data[i];
	double V=vocce.x[i];
	Qcap=V*C/q;
	nk.x[i]=inter_get(&vocce,voctau.x[i]);
	nk.x[i]/=q;
	nk.x[i]-=Qcap;
	//printf("%le %le %le\n",in->xlen,in->zlen,in->ylen);
	nk.x[i]/=(in->xlen*in->zlen*in->ylen);
double n=nk.x[i];
double l=2.0;
double n0=1.125e+20;
printf("%le\n",tau);
nk.data[i]=pow(n,l-1)/((1.0+l)*tau*pow(n0,l));

}
//printf("%le\n",(in->xlen*in->zlen*in->ylen));
inter_save(&voctau,"./exp/tpv/cetau.dat");
inter_save(&nk,"./exp/tpv/nk.dat");
inter_free(&nk);
inter_free(&vocce);
inter_free(&voctau);
}
//</clean>
